<?php
/**************************************************************
 *                                                            *
 *   Provides a notification to the user everytime            *
 *   your WordPress theme is updated                          *
 *                                                            *
 *   Author: Joao Araujo                                      *
 *   Profile: http://themeforest.net/user/unisphere           *
 *   Follow me: http://twitter.com/unispheredesign            *
 *                                                            *
 **************************************************************/

if( tie_get_option('notify_theme') && is_admin() ):

define( 'MTHEME_NOTIFIER_CACHE_INTERVAL', 43200 );

// Adds an update notification to the WordPress Dashboard menu
function tie_update_notifier_menu() {
	if ( function_exists('wp_get_theme') ) { // Stop if simplexml_load_string funtion isn't available
	  $xml 		= tie_get_latest_theme_version(MTHEME_NOTIFIER_CACHE_INTERVAL); // Get the latest remote XML file on our server
		$theme_data = wp_get_theme( THEME_FOLDER ); // Read theme current version from the style.css

         if( !empty( $xml->latest ) && version_compare( $xml->latest, $theme_data['Version'], '>') ) { // Compare current theme version with the remote XML version
			add_submenu_page('panel', THEME_NAME . __( 'بروزرسانی', 'tie' ), __( 'بروزرسانی', 'tie' ) . ' <span class="update-plugins tie-theme-update"><span class="update-count">'.__( 'جدید', 'tie' ).'</span></span>','administrator', 'theme-update-notifier' , 'tie_update_notifier');
		}
	}
}
add_action('admin_menu', 'tie_update_notifier_menu', 99999);


// The notifier page
function tie_update_notifier() {
	if( function_exists('wp_get_theme') ){
		$xml 		= tie_get_latest_theme_version(MTHEME_NOTIFIER_CACHE_INTERVAL); // Get the latest remote XML file on our server
		$theme_data = wp_get_theme( THEME_FOLDER ); // Read theme current version from the style.css
	}?>
	<style>
		.update-nag { display: none; }
		#instructions {
			font-size: 110%;
		}
		#instructions p {
			font-size: 110%;
		}
		#instructions i {
			background: #FFF8D6;
			padding: 0 4px;
		}
		a.check-changelog{
		    display: inline-block;
		    margin: 10px auto;
		    text-align: center;
		    vertical-align: middle;
		    cursor: pointer;
		    box-sizing: border-box;
		    word-wrap: break-word;
		    text-decoration: none;
		    -webkit-transition: all 0.2s ease-in-out;
		    transition: all 0.2s ease-in-out;
		    line-height: normal;
		    font-size: 14px;
		    padding-top: 14px;
		    padding-bottom: 14px;
		    padding-left: 20px;
		    padding-right: 20px;
			color: #ffffff !important;
		    background-color: #6dab3c;
		    outline: 0 !important;
		    font-weight: bold;
		}
		a.check-changelog:hover,
		a.check-changelog:focus,
		a.check-changelog:active{
			background-color: #5f9434;
		}

	</style>

	<div class="wrap">


		<div id="icon-tools" class="icon32"></div>
		<h2>بروزرسانی قالب صحیفه</h2>

		<div id="message" class="updated below-h2">
			<p>
				<strong><?php printf( __( 'نسخه جدید قالب صحیفه آماده دانلود می باشد.', 'tie' ), THEME_NAME ) ?> </strong> همین حالا میتوانید با مراجعه به پنل پشتیبانی خود در سایت فریش تم اقدام به آپدیت این قالب بکنید.
			</p>
		</div>

		<img style="margin: 0 0 20px 0; border: 1px solid #ddd; max-width:400px; height:auto;" src="<?php echo get_stylesheet_directory_uri() . '/screenshot.png'; ?>" />

		<div id="instructions">


			<h2><?php _e( 'دریافت بروزرسانی', 'tie' ) ?></h2>
			<a class="check-changelog" href="http://crm.farishtheme.ir" target="_blank"><?php _e( 'ورود به پنل کاربری', 'tie' ) ?></a>
		</div>
	</div>

<?php }



// Get the remote XML file contents and return its data (Version and Changelog)
// Uses the cached version if available and inside the time interval defined
function tie_get_latest_theme_version($interval) {
	$notifier_file_url 			 = NOTIFIER_XML_FILE;
	$db_cache_field 			 = 'notifier-cache-'.THEME_NAME;
	$db_cache_field_last_updated = 'notifier-cache-last-updated-'.THEME_NAME;
	$last 						 = get_option( $db_cache_field_last_updated );
	$now 						 = time();
	// check the cache
	if ( !$last || (( $now - $last ) > $interval) ) {
		// cache doesn't exist, or is old, so refresh it

		$cache = wp_remote_retrieve_body( wp_remote_get( $notifier_file_url , array( 'sslverify' => false ) ) );

		if ($cache) {
			// we got good results
			update_option( $db_cache_field, $cache );
			update_option( $db_cache_field_last_updated, time() );
		}
		// read from the cache file
		$notifier_data = get_option( $db_cache_field );
	}
	else {
		// cache file is fresh enough, so read from it
		$notifier_data = get_option( $db_cache_field );
	}

	// Let's see if the $xml data was returned as we expected it to.
	// If it didn't, use the default 1.0.0 as the latest version so that we don't have problems when the remote server hosting the XML file is down
	if( strpos((string)$notifier_data, '<notifier>') === false ) {
		$notifier_data = '<?xml version="1.0.0" encoding="UTF-8"?><notifier><latest>1.0.0</latest></notifier>';
	}

	// Load the remote XML data into a variable and return it
	$xml = @simplexml_load_string($notifier_data);

	return $xml;
}

endif;
